      SUBROUTINE SVCOMP(MODE,FIRST)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL STRFON,FIRST,FIRSTR
      LOGICAL MINON,MAXON
      DOUBLE PRECISION QMASS
      EQUIVALENCE (QMASS,DMASS)
      COMMON /STRFST/ XPARTN(2),BE(2),STRFON(2)
      COMMON /KINMTC/ LVIN(10,10), LVOUT(10,10,2)
      COMMON/RANDM0/IDUM       
      COMMON/INVCUT/ LVINVC(10,60),MINON(60),MAXON(60),
     &CVMIN(60),CVMAX(60)
      COMMON/INVREG/LVINVR(10,200),RGMASS(200),RGWDTH(200),NEXTRG(200),
     &NDEG(200)
      CHARACTER*6 PINF,PNAME_
      COMMON /SERVIS/NIN_,NOUT_,PMAS_(10),PNAME_(10)
      LOGICAL FILEON
      COMMON/MCINTR/ NCALL0,ITMX0,FILEON,MDS0
      COMMON /SQS/ SQRTS,RAPID
      CHARACTER*30 PROCES
      COMMON/PROCES/NSUB,PROCES

      SAVE  /STRFST/,/KINMTC/,/INVCUT/

      SAVE   
      WRITE(MODE) NIN(),NOUT()
      NINOUT=NIN()+NOUT()
      DO 10 I=1, NINOUT
        CALL PMAS(NSUB,I,DMASS)
        IF(LENR().EQ.16) THEN 
           PMAS_(I)=QMASS
        ELSE
           PMAS_(I)=DMASS
        ENDIF
10    CONTINUE
      WRITE(MODE) (PMAS_(L) ,L=1,NINOUT)
      WRITE(MODE) (PINF(NSUB,L) ,L=1,NINOUT)
      IF(NIN().EQ.2) THEN
         WRITE(MODE) STRFON,BE,SQRTS,RAPID
      ENDIF
      WRITE(MODE) LVIN, LVOUT
      WRITE(MODE) LVINVC,MINON,MAXON,CVMIN,CVMAX
      WRITE(MODE) LVINVR,RGMASS,RGWDTH,NEXTRG,NDEG
      WRITE(MODE) NCALL0,ITMX0,MDS0
      WRITE(MODE) IDUM,FIRST
      IDUM=-ABS(IDUM)    
      RETURN
     
      ENTRY RDCOMP(MODE,FIRSTR)
      READ(MODE) NIN_,NOUT_  
      NINOUT=NIN_+NOUT_     
      READ(MODE) (PMAS_(L) ,L=1,NINOUT)
      READ(MODE) (PNAME_(L) ,L=1,NINOUT)
      IF(NIN_.EQ.2) THEN
         READ(MODE) STRFON,BE,SQRTS,RAPID
      ENDIF
      READ(MODE) LVIN, LVOUT
      READ(MODE) LVINVC,MINON,MAXON,CVMIN,CVMAX
      READ(MODE) LVINVR,RGMASS,RGWDTH,NEXTRG,NDEG 
      READ(MODE) NCALL0,ITMX0,MDS0
      READ(MODE) IDUM,FIRSTR
      IDUM=-ABS(IDUM)
      RETURN
      END

